# yaml-language-server: $schema=https://gitlab.com/sbenv/veroxis/ezd-rs/-/raw/master/ezd.schema.json
tasks:
  shell_exec:
    all:
      commands:
        - ezd run fix
        - ezd run check
        - ezd run build
        - ezd run build:docs
    fix:
      commands:
        - ezd run fix:fmt
        - ezd run fix:clippy
    check:
      commands:
        - ezd run check:fmt
        - ezd run check:clippy
        - ezd run check:tests
    build:
      commands:
        - ezd run build:debug
        - ezd run build:release
    clean:
      commands:
        - ezd run rust -- cargo clean
        - rm -rf target
    check:tests:
      commands:
        - ezd run rust -- "cargo-zigbuild test --all-features"
    check:fmt:
      commands:
        - ezd run rust -- "cargo +nightly fmt -- --check"
    check:clippy:
      commands:
        - ezd run rust -- "cargo clippy --all-features -- -D warnings"
    fix:fmt:
      commands:
        - ezd run rust -- "cargo +nightly fmt"
    fix:clippy:
      commands:
        - ezd run rust -- "cargo clippy --fix --allow-dirty --allow-staged --all-targets --all-features -- -D warnings"
    build:debug:
      commands:
        - ezd run rust -- "cargo zigbuild --target=x86_64-unknown-linux-musl"
    build:release:
      commands:
        - ezd run rust -- "cargo +nightly zigbuild -Z build-std=std,panic_abort -Z build-std-features=panic_immediate_abort --target=x86_64-unknown-linux-musl --release"
    build:docs:
      commands:
        - ezd run rust -- "cargo doc"
  docker_seq:
    rust:
      config:
        image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.80.1-x86_64-unknown-linux-musl
        workdir: /app
        volumes:
          - .:/app
          - cache_docker-seq:/usr/local/cargo/registry
        sequence:
          - user: 0:0
            commands:
              - useradd --create-home --uid "__EZD_HOST_UID__" "__EZD_HOST_USERNAME__"
              - chown -R "__EZD_HOST_UID__:__EZD_HOST_GID__" "/usr/local/cargo/registry"
          - local_user: true
            commands: [set -eux && $EZD_FORWARDED_ARGS]

volumes:
  cache_docker-seq:
